<script setup lang="ts">
const isSearch = ref(false)
const fixBtn = {
  add: false,
  edit: false,
  delete: true
}

const tableHeaders = reactive([
  { title: '日期' },
  { title: '星期' },
  { title: '簽到時間' },
  { title: '簽退時間' },
  { title: '時數' }
])

const tableData = reactive([
  {
    date: '2023/03/05',
    week: '三',
    startTime: '9:00',
    endTime: '18:00',
    totalHour: '8'
  },
  {
    date: '2023/03/06',
    week: '四',
    startTime: '9:00',
    endTime: '18:00',
    totalHour: '8'
  }
])

const pageObj = reactive({
  pageItems: 10, // 一頁秀幾筆
  currentPage: 1, // 當前頁數
  pageSize: 5 // 分頁中間數字最多顯示的數目
})

// 總頁數
const totalPage = computed(() => {
  return Math.ceil(tableData.length / pageObj.pageItems)
})

const nowPage = computed(() => {
  const min = (pageObj.currentPage - 1) * pageObj.pageItems
  const max = min + pageObj.pageItems - 1
  return { min, max }
})

// 篩出來渲染的資料
const showData = computed(() => {
  return tableData.filter((item, index) => {
    return index >= nowPage.value.min && index < nowPage.value.max + 1
  })
})

const onCreated = (val: any) => {
  console.log('parent add', val)
}

const onEdit = (val: any) => {
  console.log('parent edit', val)
}

const onDelete = (val: any) => {
  console.log('parent delete', val)
}

const turnPage = (val: any) => {
  pageObj.currentPage = val
}

function onSubmit() {
  isSearch.value = true
}
</script>

<template>
  <main class="container-fluid">
    <header>
      <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
          <li class="font-zh-small-regular breadcrumb-item">
            <a href="#">業務活動資料登錄</a>
          </li>
          <li
            aria-current="page"
            class="font-zh-small-regular breadcrumb-item active"
          >
            業務出勤記錄
          </li>
        </ol>
      </nav>
      <div class="d-flex justify-content-end w-100">
        <img
          alt="header-illustration"
          class="header-illustration"
          src="@/assets/images/header-illustration.svg"
        />
      </div>
      <div class="function-group">
        <div class="display-info">
          <h3 class="font-zh-h3">簽到/簽退</h3>
        </div>
      </div>
      <div class="single-operation-board card">
        <div class="d-flex">
          <h3 class="font-zh-h3 text-color-main">打卡補登</h3>
          <p class="ms-3">員工: 林佐鳳</p>
        </div>
        <form>
          <div class="card-body">
            <div class="row">
              <div class="col-12">
                <div class="row align-items-end">
                  <div class="col-3">
                    <div class="input-item">
                      <label class="font-zh-p-medium form-label"
                        >業務代表</label
                      >
                      <common-select-multi />
                    </div>
                  </div>
                  <div class="col-3">
                    <div class="input-item">
                      <label
                        class="font-zh-p-medium form-label"
                        for="userAccount"
                        >日期</label
                      >
                      <common-calendar-date />
                    </div>
                  </div>
                  <div class="col-3">
                    <div class="input-item">
                      <label
                        class="font-zh-p-medium form-label"
                        for="userAccount"
                        >時間</label
                      >
                      <common-calendar-time />
                    </div>
                  </div>
                  <div class="col-3">
                    <div class="d-grid gap-2">
                      <button
                        class="btn btn-large-secondary font-zh-button d-flex justify-content-center align-items-center"
                        type="submit"
                      >
                        <p>打卡</p>
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </form>
      </div>
      <div>
        <basic-table
          :fix-btn="fixBtn"
          :table-data="showData"
          :table-headers="tableHeaders"
          @add="onCreated"
          @delete="onDelete"
          @edit="onEdit"
        />
        <table-pagination
          :page-obj="pageObj"
          :total-page="totalPage"
          @turn-page="turnPage"
        />
      </div>
    </header>
  </main>
</template>

<style lang="scss" scoped>
/** style */
</style>
